// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic','ngCordova','starter.controllers','starter.services','ionic-citypicker','highcharts-ng'])


.run(function($interval,misc,$ionicPlatform,$rootScope,$state,$location,$ionicPopup,DB,findPictureByStatus){
    // $state.go('cover');
    $rootScope.coverText={};
    //全局加入计时弹出功能
    $rootScope.giveRegisterHint=$interval(function(){
        // var d=new Date();
        // if(d.getMinutes()==0||15||30||45){
            console.log('运行检测登陆');
            misc.giveRegisterHint();
        // }
    },900000);   //60000是一分钟    900000是15分钟


    findPictureByStatus()
    .success(function(res){
        // console.log('首页文字');
        if(res.success==true){
            if(res.content.length){
                $rootScope.coverText.chinese=res.content[0].descr;
                $rootScope.coverText.english=res.content[0].additionalDescr;
            }
        // console.log(res);
        }
    })
    $rootScope.cover=0;
    // DB.openDB('zxj',1);


    $rootScope.returnUpper=function(){
        // alert('原始的returnUpper');
    };
    $ionicPlatform.registerBackButtonAction(function(e){
        e.preventDefault();

        function showConfirm() {  
            var confirmPopup = $ionicPopup.confirm({  
                title: '<strong>退出应用?</strong>',  
                template: '你确定要退出应用吗?',  
                okText: '退出',
                okType:'button,button-xdf',
                cancelText: '取消',
                cancelType:'button,button-xdf',
            });

            confirmPopup.then(function (res) {  
                if (res) {  
                    ionic.Platform.exitApp();  
                } else {  
                    // Don't close  
                }  
            });  
        }  

        if($location.path() == '/studyOption'||$location.path()=='/studyOption/studyOptionContent'){
            showConfirm();  
        }else if($location.path()=='/paragraph'){
            // alert(a);
            $rootScope.returnParagraphWave();
        }else if($location.path()=='/paragraphWave'||$location.path()=='/word'){
            $rootScope.returnStudyOption(); //带有停止监视的功能
        }else if($state.current.url=='/sentence/:from'){
            $rootScope.returnToFrom();
        }else if($location.path()=='/editProfile'){
            $rootScope.returnLogin();
        }else if($location.path()=='/wordPage'){
            $rootScope.returnWord();
        }else if($location.path()=='/testWord'||$location.path()=='/flashWord'){
            $rootScope.returnWordPage();
        }else if($state.current.url=='/article/:aid'){
            $rootScope.returnArticleList();
        }else if($location.path()=='/myEvaluate'){
            $rootScope.endMyEvaluate();
        }else if($location.path()=='/studyOption/contactUs'){
            $rootScope.returnStudyOption();
        }else if($location.path()=='/forgetPassword'){
            $rootScope.returnUpper();
        }
        else{
            $rootScope.returnUpper(); //纯粹的返回主界面
        }

    },120);

})
    // .run(function ($rootScope, $ionicPlatform, $cordovaNetwork, $cordovaBatteryStatus, $cordovaLocalNotification, $cordovaPush) {

    //     $ionicPlatform.ready(function () {
    //         // if (window.cordova && window.cordova.plugins.Keyboard) {
    //         //     cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    //         // }
    //         if (window.StatusBar) {
    //             StatusBar.styleDefault();
    //         }

    //         $cordovaLocalNotification.registerPermission().then(function () {
    //             //alert("registered");
    //         }, function () {
    //             //alert("denied registration");
    //         });

    //         var iosConfig = {
    //             "badge": true,
    //             "sound": true,
    //             "alert": true
    //         };
    //         $cordovaPush.register(iosConfig).then(function (result) {
    //             //alert("device token: " + result.deviceToken);
    //         }, function (error) {
    //             //alert("error " + error);
    //         });

    //         $rootScope.$on('$cordovaPush:notificationReceived', function (event, notification) {
    //             if (notification.alert) {
    //                 navigator.notification.alert(notification.alert);
    //             }
    //             if (notification.sound) {
    //                 var snd = new Media(event.sound);
    //                 snd.play();
    //             }
    //             if (notification.badge) {
    //                 $cordovaPush.setBadgeNumber(notification.badge).then(function (result) {
    //                     // Success!
    //                 }, function (err) {
    //                     // An error occurred. Show a message to the user
    //                 });
    //             }
    //         });


    //         $rootScope.$on("$cordovaNetwork:offline", function (event, result) {
    //             alert("Device is now Offline!");
    //         });


    //         $rootScope.$on("$cordovaNetwork:online", function (event, result) {
    //             alert("Device is Online!");
    //         });

    //         $rootScope.$on("$cordovaBatteryStatus:status", function (event, status) {
    //             //alert("status: " + status);
    //         })
    //     })
    // })
.config(function($ionicConfigProvider) {
  $ionicConfigProvider.views.maxCache(0);
})

.config(['$ionicConfigProvider',function($ionicConfigProvider) {
    // $ionicConfigProvider.platform.android.tabs.style('standard');
    $ionicConfigProvider.platform.android.tabs.position('bottom');
}])
// .config(['highchartsNGProvider', function (highchartsNGProvider) {
//     highchartsNGProvider.lazyLoad();// will load hightcharts (and standalone framework if jquery is not present) from code.hightcharts.com
//     highchartsNGProvider.lazyLoad([highchartsNGProvider.HIGHCHART/HIGHSTOCK, "maps/modules/map.js", "mapdata/custom/world.js"]);// you may add any additional modules and they will be loaded in the same sequence
//     highchartsNGProvider.basePath("/js/"); // change base path for scripts, default is http(s)://code.highcharts.com/

// }])

.config(function($stateProvider, $urlRouterProvider) {

    



  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
    $stateProvider

  // setup an abstract state for the tabs directive
    .state('cover',{
        url:'/cover',
        templateUrl: "templates/cover.html",
        controller:function($timeout,$state){
            $timeout(function(){
                // alert();
                $state.go('login');
            },3000);
        }
    })
    .state('studyOption',{
        url:'/studyOption',
        templateUrl: 'templates/studyOption.html',
        // controller:'studyOption'
    })
    .state('studyOption.login', {
        url: "/login",
        views:{
            'login':{
                templateUrl: "templates/login.html",
                controller: 'login'
            }
        }
    })
    .state('studyOption.studyOptionContent',{
        url:'/studyOptionContent',
        views:{
            'studyOptionContent':{
                templateUrl:'templates/studyOptionContent.html',
                controller:'studyOption'
            }
        }
    })
    .state('studyOption.contactUs',{
        url:'/contactUs',
        views:{
            'contactUs':{
                templateUrl:'templates/contactUs.html',
                controller:'contactUs'
            }
        }
        // controller:''
    })
    .state('studyOption.pattrnSetting',{
        url:'/pattrnSetting',
        views:{
            'pattrnSetting':{
                templateUrl:'templates/pattrnSetting.html',
                controller:'pattrnSetting'
            }
        }
    })
    .state('forgetPassword',{
        url:'/forgetPassword',
        templateUrl:'templates/forgetPassword.html',
        controller:'forgetPassword'
    })
    .state('loginRegist',{
        url:'/loginRegist',
        templateUrl: 'templates/loginRegist.html',
        controller: 'loginRegister'
    })
    .state('myEvaluate',{
        url:'/myEvaluate',
        templateUrl: 'templates/myEvaluate.html',
        controller:'myEvaluate'
    })
    .state('point',{
        url:'/point',
        templateUrl: 'templates/point.html'
    })
    .state('user',{
        url:'/user',
        templateUrl:'templates/user.html',
        controller:'user'
    })
    .state('aboutUs',{
        url:'/aboutUs',
        templateUrl:'templates/aboutUs.html',
        controller:'aboutUs'
    })
    .state('faq',{
        url:'/faq',
        templateUrl:'templates/faq.html',
        controller:'faq'
    })
    .state('question',{
        url:'/question/:aid',
        templateUrl: 'templates/question.html',
        controller:'question'
    })
    .state('word',{
        url:'/word',
        resolve:{
            changeWordStatus:function(wordsStatus){
                wordsStatus.saveStatus(0);
            }
        },
        templateUrl:'templates/word.html',
        controller:'word'
    })
    .state('editProfile',{
        url:'/editProfile',
        templateUrl:'templates/editProfile.html',
        controller:'editProfile'
    })
    .state('statistics',{
        url:'/statistics',
        templateUrl:'templates/statistics.html',
        controller:'statistics'
    })
    .state('wordPage',{
        url:'/wordPage/:from',
        resolve:{
            getWords:'getWords',
            wordsStatus:"wordsStatus",
            userinfo:'userinfo',
            active:function(wordsStatus,getWords,userinfo,$window,$timeout,learning){
                var words=getWords.conditional();
                var user=userinfo.getUser();
                // wordsStatus.saveStatus(1);
                var wordStatus=wordsStatus.getStatus();
                // console.log(words);
                var _len=words.length;
                var timer=[];
                var countTimer='';
                var actionarr=[];
                console.log(wordStatus);
                // console.log(user);
                for(var i=0;i<_len;i++){
                    if(wordStatus==1){
                        //使用原有的旧的学习记录
                        // var _a=angular.fromJson($window.localStorage['nowWordActionId.'+i])
                        // timer[i]=_a.record.duration||0;
                        if(!angular.isNumber(timer[i])){
                            timer[i]=0;
                        }
                    }else{
                        timer[i]=0;
                        //开始这批单词新的学习记录
                        learning.startWordLearning(i,words[i].id,'',user.id)
                    }
                }

                $timeout(function(){
                    for (var i=0 ;i<_len;i++) {
                        actionarr.push(angular.fromJson($window.localStorage['nowWordActionId.'+i]));
                    }
                    console.log(actionarr);
                    // $scope.startCountTime(0);
                },2000);
                return {
                    'words':words,
                    'timer':timer,
                    'actionarr':actionarr,
                    'user':user,
                    'wordStatus':wordStatus,
                    '_len':_len,

                }
            }
            // scope:"$scope",
        },
        templateUrl:'templates/wordPage.html',
        controller:'wordPage',
        onEnter:function(wordsStatus,getWords,userinfo,$window,$timeout){
                      
        }
    })
    .state('testWord',{
        url:"/testWord",
        templateUrl:'templates/testWord.html',
        controller:'testWord'
    })
    .state('flashWord',{
        url:'/flashWord',
        templateUrl:'templates/flashWord.html',
        controller:'flashWord'
    })
    .state('errorQuestion',{
        url:'/errorQuestion/:from',
        templateUrl:'templates/errorQuestion.html',
        controller:'errorQuestion'
    })
    .state('paragraphWave',{
        url:'/paragraphWave/:phase',
        templateUrl:'templates/paragraphWave.html',
        controller:'paragraphWave'
    })
    // state('',{
    //     url:'/'
    // })
    .state('paragraph',{
        url:'/paragraph/:from',
        resolve:{
            // learning:'learning',
            // paragraphInfo:'paragraphInfo',
            active:function(paragraphInfo,learning,$window,$interval,countTimer){
                var timer;
                var action;
                var paragraphStatus=paragraphInfo.getParagraphStatus();
                console.log(paragraphStatus);
                if(paragraphStatus==0){
                    countTimer.clearTimer();
                }else{
                    
                }
                // timer=countTimer.getTimer();
                countTimer.startTimer();
                action=angular.fromJson($window.localStorage['nowParagraphAction']);
                console.log('显示段落action');
                // console.log(action);
                return {
                    'action':action,
                    'timer':timer,
                    'paragraphStatus':paragraphStatus,

                }
            }
        },
        templateUrl:'templates/paragraph.html',
        controller:'paragraph',

    })
    .state('sentence',{
        url:'/sentence/:from',
        resolve:{
            active:function(userinfo,sentenceInfo,learning,$window,$interval,countTimer,$stateParams){
                var timer;
                var action;
                var sentenceStatus=sentenceInfo.getSentenceStatus();
                console.log(sentenceStatus);
                if(sentenceStatus==0){
                    countTimer.clearTimer();
                    
                }else{
                    
                }
                countTimer.startTimer();
                action=angular.fromJson($window.localStorage['nowSentenceAction']);
                console.log('显示句子action');
                // console.log(action);
                return {
                    'action':action,
                    'timer':timer,
                    'sentenceStatus':sentenceStatus,
                }
            }
        },
        templateUrl:'templates/sentence.html',
        controller:'sentence'
    })
    .state('article',{
        url:'/article/:aid/:from',
        resolve:{
            active:function(userinfo,learning,$window,countTimer,articleInfo,$stateParams){
                // var action;
                // var articleStatus=articleInfo.getArticleStatus();
                var user=userinfo.getUser();
                // // console.log(user);
                // console.log(articleStatus);
                // if(articleStatus==0||angular.isUndefined(articleStatus)){

                //     countTimer.clearTimer();
                //     // console.log($stateParams.aid);

                //     learning.getReleasedArticle($stateParams.aid)
                //     .success(function(res){
                //         // console.log('res二层');
                //         console.log(res.id);
                //         console.log(user);

                //         learning.startArticleLearning(res.id,user.id)
                //         .success(function(res){
                //             console.log('三层');
                //             articleInfo.saveArticleAction(res);
                //             action=articleInfo.getArticleAction();
                //             console.log(action);
                //         })
                //     })
                // }else{
                    
                // }
                // countTimer.startTimer();
                // // action=angular.fromJson($window.localStorage['nowArticleAction']);
                return {
                    'user':user,
                }
            }
        },
        templateUrl:'templates/article.html',
        controller:'article'
    })
    .state('articleList',{
        url:'/articleList',
        templateUrl:'templates/articleList.html',
        controller:'articleList'
    })
    .state('showResult',{
        url:'/showResult/:from',
        resolve:{
            active:function(evaluateResult,userinfo){
                var user=userinfo.getUser();
                var getResult;
                getResult=evaluateResult.getResult(user.id);
                return {
                    'getResult':getResult,
                }
            }
        },
        templateUrl:'templates/showResult.html',
        controller:'showResult',
    })
    .state('compareResult',{
        resolve:{
            active:function(proActions,$stateParams){
                var from=$stateParams.from;
                return proActions.findLastSpecifiedActionGroup(from,2)
                .success(function(res){
                    // console.log('resolve');
                    // console.log(res);
                    var lastActions=res.content;
                    return {
                        'lastActions':lastActions
                    }
                });
            }
        },
        url:'/compareResult/:from',
        templateUrl:'templates/compareResult.html',
        controller:'compareResult'
    })
    .state('showSubCover',{
        url:'/showSubCover',
        templateUrl:'templates/showSubCover.html',
        controller:'showSubCover'
    })
    .state('showHistory',{
        url:'/showHistory',
        templateUrl:'templates/showHistory.html',
        controller:'showHistory'
    })
    .state('ngTest',{
        url:'/ngtest',
        templateUrl:'templates/ngtest.html',
        controller:'ngtestC'
    })
    ;
  // if none of the above states are matched, use this as the fallback
    $urlRouterProvider.otherwise('/showSubCover');

});
