myService.factory('waveandwave', ['learning','paragraphInfo',function(learning,paragraphInfo){
    

    var watchID = null;
    var oldX = 5, oldY = 5,oldZ=5,timestamp=0;
    var distance=0;
    var pendingDistance=20;
    var deviceStatus='waiting';  //这里状态应该有   waiting   waving  
    var onSuccess=function(newValue){
        console.log('执行到onSuccess');
        diffX = Math.abs(newValue.x-oldX);
        diffY = Math.abs(newValue.y-oldY);
        diffZ = Math.abs(newValue.z-oldZ);
        timestamp = newValue.timestamp;
        distance=diffX+diffY+diffZ;
        console.log(distance);

        if(distance>pendingDistance){
            if(deviceStatus!='waving'){
                startWave(newValue.x,newValue.y,newValue.z); //开始摇一摇特效
            }else{
                continueDoing(newValue.x,newValue.y,newValue.z,distance); //持续一部分特效
            }
        }else{
            if(deviceStatus=='waving'){
                stopWave(newValue.x,newValue.y,newValue.z,distance); // 停止摇一摇特效， 给出结果   改变deviceStatus标示为waiting
            }
        }

        //最后要把 新值传给旧值 供下一次使用
        oldX = newValue.x;
        oldY = newValue.y;
        oldZ = newValue.z;
    }

    var onError=function() {
        $cordovaDialogs.alert('onError!');
    }

    function startWave(x,y,z){
        var accepsd =  'X: ' + x  + '/Y: ' + y + '/Z: ' + z ;
        //$cordovaDialogs.alert(accepsd)
        var element = null;
        
        var element = document.getElementById('accelerometer_div');
        element.innerHTML = accepsd;

        deviceStatus='waving';
        
    }
    function continueDoing(x,y,z,d){
        var accepsd = "continueDoing:<br>"+ 'X: ' + x  + '/Y: ' + y + '/Z: ' + z +"<br>distance:"+d;
        //$cordovaDialogs.alert(accepsd)
        var element = document.getElementById('accelerometer_div');
        element.innerHTML = accepsd;
    }

    function stopWave(x,y,z,d){
        var accepsd = "stop:<br>"+ 'X: ' + x  + '/Y: ' + y + '/Z: ' + z +"<br>distance:"+d;
        //$cordovaDialogs.alert(accepsd)
        var element = document.getElementById('accelerometer_div');
        element.innerHTML = accepsd;
        deviceStatus='waiting';
        // var element = document.getElementById('accelerometer_div');
        // element.innerHTML = '';

        var _ajax=learning.listRandomParagraphs();
        _ajax.success(function(res){
            paragraphInfo.saveParagraph(res[0]);
            paragraphInfo.saveParagraphStatus(0);
            console.log('显示摇一摇段落');
            console.log(res[0]);
            // $scope.para=res[0];
            return res[0];
        });

    }

    return  {
        startWatch:function(){
            var options = { frequency: 300 };
            watchID = navigator.accelerometer.watchAcceleration(onSuccess, onError, options);
        },
        stopWatch:function(){
            if (watchID) {
                navigator.accelerometer.clearWatch(watchID); watchID = null;
            }
        }
    }
}]);